#include "gm.h"

gmexport double listeningsocket_create(double ipv6, double port) {
	ListeningSocket *ls = NULL; // GCC is complaining for some reason ...
	ls = new ListeningSocket();
	try {
		char buffer[21];
		ls->Create(gm_double_to_bool(ipv6), ulong_to_str(buffer, gm_double_to_ulong(port)));
		GMData_ListeningSocket temp;
		temp.id = ++(gmdata.idcounter_listeningsockets);
		temp.ptr = ls;
		gmdata.listeningsockets.push_back(temp);
	}
	catch(...) {
		delete ls;
		throw;
	}
	return gmdata.idcounter_listeningsockets;
}
gmexport double listeningsocket_destroy(double id) {
	unsigned long ul_id = gm_double_to_ulong(id);
	for(unsigned int i = 0; i<gmdata.listeningsockets.size(); ++i) {
		if(gmdata.listeningsockets[i].id==ul_id) {
			ListeningSocket *ls = gmdata.listeningsockets[i].ptr;
			gmdata.listeningsockets.erase(gmdata.listeningsockets.begin()+i);
			delete ls;
			return 1;
		}
	}
	return 0;
}
gmexport double listeningsocket_exists(double id) {
	ListeningSocket *ls = gmdata.FindListeningSocket(gm_double_to_ulong(id));
	return (ls==NULL)? 0 : 1;
}

gmexport double listeningsocket_error(double id) {
	ListeningSocket *ls = gmdata.FindListeningSocket(gm_double_to_ulong(id));
	if(ls==NULL) return 0;
	return (ls->GetState()==LISTENINGSOCKETSTATE_ERROR)? 1 : 0;
}

gmexport double listeningsocket_can_accept(double id) {
	ListeningSocket *ls = gmdata.FindListeningSocket(gm_double_to_ulong(id));
	if(ls==NULL) return 0;
	return (ls->CanAccept())? 1 : 0;
}
gmexport double listeningsocket_accept(double id) {
	ListeningSocket *ls = gmdata.FindListeningSocket(gm_double_to_ulong(id));
	if(ls==NULL) return 0;
	Socket *s = NULL; // GCC is complaining for some reason ...
	s = new Socket();
	try {
		ls->Accept(s);
		GMData_Socket temp;
		temp.id = ++(gmdata.idcounter_sockets);
		temp.ptr = s;
		gmdata.sockets.push_back(temp);
	}
	catch(...) {
		delete s;
		throw;
	}
	return gmdata.idcounter_sockets;
}

