#include "gm.h"

MD5 shared_md5;

gmexport double md5_begin() {
	shared_md5.Begin();
	return 1;
}
gmexport double md5_end() {
	shared_md5.End();
	return 1;
}
gmexport double md5_read_file(const char* filename) {
	return (shared_md5.ReadFile(filename))? 1 : 0;
}
gmexport double md5_read_string(const char* string) {
	shared_md5.ReadMem(string, strlen(string));
	return 1;
}
gmexport double md5_read_buffer(double id) {
	Buffer *b = gmdata.FindBuffer(gm_double_to_ulong(id));
	if(b==NULL) return 0;
	shared_md5.ReadMem(b->GetData(), b->GetLength());
	return 1;
}
gmexport double md5_read_buffer_part(double id, double pos, double len) {
	Buffer *b = gmdata.FindBuffer(gm_double_to_ulong(id));
	if(b==NULL) return 0;
	unsigned long l = b->GetLength();
	unsigned long _pos = gm_double_to_ulong(pos);
	unsigned long _len = gm_double_to_ulong(len);
	if(_pos>l) _pos = l;
	if(_len>l-_pos) _len = l-_pos;
	shared_md5.ReadMem(b->GetData()+_pos, _len);
	return 1;
}
gmexport const char* md5_result() {
	returnstring.Clear();
	returnstring.SetLength(32);
	bintohex((const char*)(shared_md5.Result()), returnstring.GetData(), 16);
	return returnstring.ToString();
}

