#ifndef MD5_H
#define MD5_H

#include <stdint.h>

class MD5 {
	
	private:
	unsigned long blocks, used; // 0 <= used < 64
	union {
		uint32_t w[4]; // 4 words
		uint8_t x[16]; // 16 bytes
	} result;
	union {
		uint32_t w[16]; // 16 words
		uint8_t x[64]; // 64 bytes
	} block;
	
	public:
	void Begin();
	bool ReadFile(const char* fname);
	void ReadMem(const void* data, unsigned long datalen);
	void End();
	inline const uint8_t* Result() { return result.x; }
	
};

void bintohex(const char* input, char* output, unsigned long inputlen);
void hextobin(const char* input, char* output, unsigned long outputlen);

#endif // MD5_H

